Package org.apache.tapestry5.internal.services

# Class PartialMarkupDocumentLinker

java.lang.Object
org.apache.tapestry5.internal.services.PartialMarkupDocumentLinker

All Implemented Interfaces:
  `DocumentLinker`

public class PartialMarkupDocumentLinker extends Object implements DocumentLinker

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PartialMarkupDocumentLinker()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addCoreLibrary(String libraryURL)`
  A special case used only for the libraries that are part of the core stack, which itself contains RequireJS and is used to bootstrap up to adding non-core libraries.
  `void`
  `addInitialization(InitializationPriority priority, String moduleName, String functionName, JSONArray arguments)`
  Adds initialization, based on invoking functions exported by JavaScript modules.
  `void`
  `addLibrary(String libraryURL)`
  Adds a link to load a non-core JavaScript library.
  `void`
  `addModuleConfigurationCallback(ModuleConfigurationCallback callback)`
  Adds a module configuration callback for this request.
  `void`
  `addScript(InitializationPriority priority, String script)`
  Adds JavaScript code.
  `void`
  `addStylesheetLink(StylesheetLink stylesheet)`
  Adds a link to load a CSS stylesheet.
  `void`
  `commit(JSONObject reply)`
  Commits changes, adding one or more keys to the reply.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### PartialMarkupDocumentLinker

    public PartialMarkupDocumentLinker()

- ## Method Details

  - ### addCoreLibrary

    public void addCoreLibrary(String libraryURL)
    Description copied from interface: `DocumentLinker`
    A special case used only for the libraries that are part of the core stack, which itself contains RequireJS and is used to bootstrap up to adding non-core libraries.
    Specified by:
      `addCoreLibrary` in interface `DocumentLinker`

  - ### addLibrary

    public void addLibrary(String libraryURL)
    Description copied from interface: `DocumentLinker`
    Adds a link to load a non-core JavaScript library. These libraries are loaded, sequentially, only once the core libraries have loaded and initialized. Thus difference between core libraries and other libraries is new in 5.4, and represents a conflict between asynchronous loading of modules (introduced in 5.4) and sequential loading of libraries (in 5.3 and earlier).
    Specified by:
      `addLibrary` in interface `DocumentLinker`

  - ### addStylesheetLink

    public void addStylesheetLink(StylesheetLink stylesheet)
    Description copied from interface: `DocumentLinker`
    Adds a link to load a CSS stylesheet.
    Specified by:
      `addStylesheetLink` in interface `DocumentLinker`

  - ### addScript

    public void addScript(InitializationPriority priority, String script)
    Description copied from interface: `DocumentLinker`
    Adds JavaScript code. The code is collected into a single block that is injected just before the close body tag of the page (in a full page render) and collected as the "script" property of the partial page render response. The JavaScript is executed after the page loads (or in an Ajax update, after external JavaScript libraries are loaded and the DOM is updated). This method may be called multiple times for the same priority and the script will be accumulated.
    Specified by:
      `addScript` in interface `DocumentLinker`
    Parameters:
      `priority` - when to execute the provided script
      `script` - statement to add to the block (a newline will be appended as well)

  - ### addModuleConfigurationCallback

    public void addModuleConfigurationCallback(ModuleConfigurationCallback callback)
    Description copied from interface: `DocumentLinker`
    Adds a module configuration callback for this request.
    Specified by:
      `addModuleConfigurationCallback` in interface `DocumentLinker`
    Parameters:
      `callback` - a `ModuleConfigurationCallback`. It cannot be null.

  - ### addInitialization

    public void addInitialization(InitializationPriority priority, String moduleName, String functionName, JSONArray arguments)
    Description copied from interface: `DocumentLinker`
    Adds initialization, based on invoking functions exported by JavaScript modules.
    Specified by:
      `addInitialization` in interface `DocumentLinker`
    Parameters:
      `priority` - priority at which to perform initialization
      `moduleName` - name of module; the module exports a single function, or a map of functions
      `functionName` - name of function exported by module, or null (if the module exports a single function)
      `arguments` - arguments to pass to the function, or null if no arguments

  - ### commit

    public void commit(JSONObject reply)
    Commits changes, adding one or more keys to the reply.
    Parameters:
      `reply` - JSON Object to be sent to client